// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: quest.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Quest {
  public static partial class QuestServices
  {
    static readonly string __ServiceName = "quest.QuestServices";

    static void __Helper_SerializeMessage(global::Google.Protobuf.IMessage message, grpc::SerializationContext context)
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (message is global::Google.Protobuf.IBufferMessage)
      {
        context.SetPayloadLength(message.CalculateSize());
        global::Google.Protobuf.MessageExtensions.WriteTo(message, context.GetBufferWriter());
        context.Complete();
        return;
      }
      #endif
      context.Complete(global::Google.Protobuf.MessageExtensions.ToByteArray(message));
    }

    static class __Helper_MessageCache<T>
    {
      public static readonly bool IsBufferMessage = global::System.Reflection.IntrospectionExtensions.GetTypeInfo(typeof(global::Google.Protobuf.IBufferMessage)).IsAssignableFrom(typeof(T));
    }

    static T __Helper_DeserializeMessage<T>(grpc::DeserializationContext context, global::Google.Protobuf.MessageParser<T> parser) where T : global::Google.Protobuf.IMessage<T>
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (__Helper_MessageCache<T>.IsBufferMessage)
      {
        return parser.ParseFrom(context.PayloadAsReadOnlySequence());
      }
      #endif
      return parser.ParseFrom(context.PayloadAsNewBuffer());
    }

    static readonly grpc::Marshaller<global::Quest.Quest> __Marshaller_quest_Quest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Quest.Quest.Parser));
    static readonly grpc::Marshaller<global::Common.QuestId> __Marshaller_common_QuestId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.QuestId.Parser));
    static readonly grpc::Marshaller<global::Common.UserId> __Marshaller_common_UserId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.UserId.Parser));
    static readonly grpc::Marshaller<global::Quest.QuestList> __Marshaller_quest_QuestList = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Quest.QuestList.Parser));
    static readonly grpc::Marshaller<global::Quest.StartQuestRequest> __Marshaller_quest_StartQuestRequest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Quest.StartQuestRequest.Parser));
    static readonly grpc::Marshaller<global::Common.ResponseStatus> __Marshaller_common_ResponseStatus = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.ResponseStatus.Parser));

    static readonly grpc::Method<global::Quest.Quest, global::Common.QuestId> __Method_AddQuest = new grpc::Method<global::Quest.Quest, global::Common.QuestId>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddQuest",
        __Marshaller_quest_Quest,
        __Marshaller_common_QuestId);

    static readonly grpc::Method<global::Common.QuestId, global::Quest.Quest> __Method_GetQuestByID = new grpc::Method<global::Common.QuestId, global::Quest.Quest>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetQuestByID",
        __Marshaller_common_QuestId,
        __Marshaller_quest_Quest);

    static readonly grpc::Method<global::Common.UserId, global::Quest.QuestList> __Method_GetQuestByUserID = new grpc::Method<global::Common.UserId, global::Quest.QuestList>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetQuestByUserID",
        __Marshaller_common_UserId,
        __Marshaller_quest_QuestList);

    static readonly grpc::Method<global::Quest.StartQuestRequest, global::Common.ResponseStatus> __Method_StartQuest = new grpc::Method<global::Quest.StartQuestRequest, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "StartQuest",
        __Marshaller_quest_StartQuestRequest,
        __Marshaller_common_ResponseStatus);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Quest.QuestReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of QuestServices</summary>
    [grpc::BindServiceMethod(typeof(QuestServices), "BindService")]
    public abstract partial class QuestServicesBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Common.QuestId> AddQuest(global::Quest.Quest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Quest.Quest> GetQuestByID(global::Common.QuestId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Quest.QuestList> GetQuestByUserID(global::Common.UserId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> StartQuest(global::Quest.StartQuestRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for QuestServices</summary>
    public partial class QuestServicesClient : grpc::ClientBase<QuestServicesClient>
    {
      /// <summary>Creates a new client for QuestServices</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public QuestServicesClient(grpc::ChannelBase channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for QuestServices that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public QuestServicesClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected QuestServicesClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected QuestServicesClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Common.QuestId AddQuest(global::Quest.Quest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddQuest(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.QuestId AddQuest(global::Quest.Quest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddQuest, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.QuestId> AddQuestAsync(global::Quest.Quest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddQuestAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.QuestId> AddQuestAsync(global::Quest.Quest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddQuest, null, options, request);
      }
      public virtual global::Quest.Quest GetQuestByID(global::Common.QuestId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetQuestByID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Quest.Quest GetQuestByID(global::Common.QuestId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetQuestByID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Quest.Quest> GetQuestByIDAsync(global::Common.QuestId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetQuestByIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Quest.Quest> GetQuestByIDAsync(global::Common.QuestId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetQuestByID, null, options, request);
      }
      public virtual global::Quest.QuestList GetQuestByUserID(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetQuestByUserID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Quest.QuestList GetQuestByUserID(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetQuestByUserID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Quest.QuestList> GetQuestByUserIDAsync(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetQuestByUserIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Quest.QuestList> GetQuestByUserIDAsync(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetQuestByUserID, null, options, request);
      }
      public virtual global::Common.ResponseStatus StartQuest(global::Quest.StartQuestRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return StartQuest(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus StartQuest(global::Quest.StartQuestRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_StartQuest, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> StartQuestAsync(global::Quest.StartQuestRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return StartQuestAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> StartQuestAsync(global::Quest.StartQuestRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_StartQuest, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override QuestServicesClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new QuestServicesClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(QuestServicesBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_AddQuest, serviceImpl.AddQuest)
          .AddMethod(__Method_GetQuestByID, serviceImpl.GetQuestByID)
          .AddMethod(__Method_GetQuestByUserID, serviceImpl.GetQuestByUserID)
          .AddMethod(__Method_StartQuest, serviceImpl.StartQuest).Build();
    }

    /// <summary>Register service method with a service binder with or without implementation. Useful when customizing the  service binding logic.
    /// Note: this method is part of an experimental API that can change or be removed without any prior notice.</summary>
    /// <param name="serviceBinder">Service methods will be bound by calling <c>AddMethod</c> on this object.</param>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static void BindService(grpc::ServiceBinderBase serviceBinder, QuestServicesBase serviceImpl)
    {
      serviceBinder.AddMethod(__Method_AddQuest, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Quest.Quest, global::Common.QuestId>(serviceImpl.AddQuest));
      serviceBinder.AddMethod(__Method_GetQuestByID, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.QuestId, global::Quest.Quest>(serviceImpl.GetQuestByID));
      serviceBinder.AddMethod(__Method_GetQuestByUserID, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.UserId, global::Quest.QuestList>(serviceImpl.GetQuestByUserID));
      serviceBinder.AddMethod(__Method_StartQuest, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Quest.StartQuestRequest, global::Common.ResponseStatus>(serviceImpl.StartQuest));
    }

  }
}
#endregion
